/* hdrs/stack.h */
/* Architecture-independent stack manipulation */

#define INIT_STACK  char *__sp=alloca(0), *__ep=__sp

#define __align(x) (sizeof(typeof(x)) <= sizeof(long) ? \
                    sizeof(long) : sizeof(typeof(x)))


#ifdef STACK_GROWS_DOWN

#define PUSH(x) ({ \
  if((__sp -= __align(x)) < __ep) \
    __ep=alloca(__align(x)); \
  *(typeof(x)*) __sp=x; \
})

#define POP(x) ({ \
  (x) = *(typeof(x)*) __sp; \
  __sp += __align(x); \
})

#else

#define PUSH(x) ({ \
  if(__sp + __align(x) > __ep) \
    __ep=alloca(__align(x)) + __align(x); \
  *(typeof(x)*) __sp=x; \
  __sp += __align(x); \
})

#define POP(x) ({ \
  __sp -= __align(x); \
  (x) = *(typeof(x)*) __sp; \
})

#endif
